Summary: MPI 2 C++ bindings
Name: mpi2c++
Version: 1.0.1
Release: 3
Copyright: Freeware
Group: Beowulf
Packager: Red Hat Contrib|Net <rhcn-bugs@redhat.com>
URL: http://www.cse.nd.edu/~lsc/research/mpi2c++/
Source: http://www.cse.nd.edu/~lsc/research/mpi2c++/MPI-2-C++-1.0.1.tar.gz
Source1: errhandler.cc
BuildRoot: /var/tmp/mpi2root
Requires: mpich >= 1.1.1, egcs-c++

%description
This is an implementation of the MPI-2 C++ bindings as determined by
the MPI Forum. The MPI-2 C++ bindings are a layer built directly on
top of the MPI-1 C bindings.

Note that with this version and egcs-1.0.3 there are problems with 
exception handling. The test suite has been modified to skip this test.
These problems should be fixed in the next release.

%changelog
* Sun Nov 15 1998 Justin Cormack <jpc1@doc.ic.ac.uk>
- RHCN release
- release 3
* Mon Nov 09 1998 Justin Cormack <jpc1@doc.ic.ac.uk>
- corrected symlink error
- release 2
* Fri Sep 11 1998 Justin Cormack <jpc1@doc.ic.ac.uk>
- minor tidying up of spec file
* Tue Sep 01 1998 Justin Cormack <jpc1@doc.ic.ac.uk>
- Small patch to errhandler.cc to run test suite
- do not make test and examples in install
- first package
- Decided that C++ was better packaged separately fromn MPICH.

%prep
%setup -n MPI-2-C++-%{PACKAGE_VERSION}

%build

./configure --prefix=$RPM_BUILD_ROOT/usr --with-mpich=/usr

# seems to be problem with Makefile
cp Makefile Makefile.orig
cat Makefile.orig | sed "s/f5'/f5/g" > Makefile
rm -f Makefile.orig

# remove -fhandle-exceptions in balky as egcs does not need it
Balkyfix() {
    while [ $# -ne 0 ]
    do
        if [ -d $1 ]
        then
            echo 'omitting directory $1'
        else
            mv $1 $1.orig
            sed \
                 -e 's/-fhandle-exceptions//g' \
                 $1.orig > $1
            rm -f $1.orig
        fi
        shift
    done
}

pushd $RPM_BUILD_DIR/MPI-2-C++-%{PACKAGE_VERSION}/balky
Balkyfix balky mini-balky
chmod +x balky mini-balky
popd

make clean lib

%install
make install

# also symlink broken in make install
pushd $RPM_BUILD_ROOT/usr/include
rm -f mpi++.h
ln -s mpi2c++-%{PACKAGE_VERSION}/mpi++.h
popd

# install examples
# first fix balky in Makefile
Fixup() {
    while [ $# -ne 0 ]
    do
        if [ -d $1 ]
        then
            echo 'omitting directory $1'
        else
            mv $1 $1.orig
            sed \
                 -e "s\\../../balky/mini-balky\\balky\\g" \
                 $1.orig > $1
            rm -f $1.orig
        fi
        shift
    done
}

mkdir -p $RPM_BUILD_ROOT/usr/doc/mpi2c++-%{PACKAGE_VERSION}/examples
mkdir -p $RPM_BUILD_ROOT/usr/doc/mpi2c++-%{PACKAGE_VERSION}/test_suite
pushd $RPM_BUILD_DIR/MPI-2-C++-%{PACKAGE_VERSION}
cp HISTORY INSTALL LICENSE README VERSION \
   $RPM_BUILD_ROOT/usr/doc/mpi2c++-%{PACKAGE_VERSION}
popd
pushd $RPM_BUILD_DIR/MPI-2-C++-%{PACKAGE_VERSION}/contrib/

pushd examples
Fixup Makefile*
popd
pushd test_suite
Fixup Makefile*
popd

cp -a examples/{Makefile*,*.cc} \
      $RPM_BUILD_ROOT/usr/doc/mpi2c++-%{PACKAGE_VERSION}/examples
cp -a test_suite/{Makefile*,*.cc,*.h} \
      $RPM_BUILD_ROOT/usr/doc/mpi2c++-%{PACKAGE_VERSION}/test_suite
popd

# temporary fix so test suite works by skipping errhandler. Remove for next
# release or if egcs 1.1 compiles this ok.
pushd $RPM_BUILD_ROOT/usr/doc/mpi2c++-%{PACKAGE_VERSION}/test_suite
mv errhandler.cc errhandler-original.cc
cp %{SOURCE1} .
popd

%clean
rm -rf $RPM_BUILD_DIR/MPI-2-C++-%{PACKAGE_VERSION}
rm -rf $RPM_BUILD_ROOT

%files
/usr/lib/libmpi++.a
/usr/include/mpi++.h
/usr/include/mpi2c++-%{PACKAGE_VERSION}/
/usr/include/mpi2c++
/usr/bin/balky
%doc /usr/doc/mpi2c++-%{PACKAGE_VERSION}/
